epm-sh-functions 9.45 KB
Newer Older
Vitaly Lipatov's avatar
Vitaly Lipatov committed
1 2
#!/bin/sh
#
3 4
# Copyright (C) 2012, 2014  Etersoft
# Copyright (C) 2012, 2014  Vitaly Lipatov <lav@etersoft.ru>
Vitaly Lipatov's avatar
Vitaly Lipatov committed
5
#
6 7 8
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
Vitaly Lipatov's avatar
Vitaly Lipatov committed
9 10 11 12 13
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14
# GNU Affero General Public License for more details.
Vitaly Lipatov's avatar
Vitaly Lipatov committed
15
#
16 17
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
Vitaly Lipatov's avatar
Vitaly Lipatov committed
18 19
#

20
# copied from /etc/init.d/outformat (ALT Linux)
21

22
# FIXME on Android: FIX ME! implement ttyname_r() bionic/libc/bionic/stubs.c:366
23 24 25
inputisatty()
{
	# check stdin
Vitaly Lipatov's avatar
Vitaly Lipatov committed
26
	tty -s 2>/dev/null
27 28
}

29 30
isatty()
{
31 32 33 34 35 36
	# check stdout
	test -t 1
}

isatty2()
{
Vitaly Lipatov's avatar
Vitaly Lipatov committed
37 38
	# check stderr
	test -t 2
39 40
}

41 42
check_tty()
{
43 44 45 46 47 48
	isatty2 || return

	# Set a sane TERM required for tput
	[ -n "$TERM" ] || TERM=dumb
	export TERM

49
	# egrep from busybox may not --color
Vitaly Lipatov's avatar
Vitaly Lipatov committed
50 51
	# egrep from MacOS print help to stderr
	if egrep --help 2>&1 | grep -q -- "--color" ; then
52
		export EGREPCOLOR="--color"
53 54
	fi

55 56 57 58
	which tput >/dev/null 2>/dev/null || return
	# FreeBSD does not support tput -S
	echo | tput -S >/dev/null 2>/dev/null || return
	[ -z "$USETTY" ] || return
59 60 61
	export USETTY=1
}

62 63 64 65
: ${BLACK:=0} ${RED:=1} ${GREEN:=2} ${YELLOW:=3} ${BLUE:=4} ${MAGENTA:=5} ${CYAN:=6} ${WHITE:=7}

set_boldcolor()
{
66
	[ "$USETTY" = "1" ] || return
67 68 69 70 71 72 73 74
	{
		echo bold
		echo setaf $1
	} |tput -S
}

restore_color()
{
75
	[ "$USETTY" = "1" ] || return
76 77 78 79 80 81
	{
		echo op; # set Original color Pair.
		echo sgr0; # turn off all special graphics mode (bold in our case).
	} |tput -S
}

Vitaly Lipatov's avatar
Vitaly Lipatov committed
82 83
echover()
{
Vitaly Lipatov's avatar
Vitaly Lipatov committed
84
    [ -z "$verbose" ] && return
85
    echo "$*" >&2
Vitaly Lipatov's avatar
Vitaly Lipatov committed
86 87
}

88 89 90
# echo string without EOL
echon()
{
Vitaly Lipatov's avatar
Vitaly Lipatov committed
91 92
	# default /bin/sh on MacOS does not recognize -n
	/bin/echo -n "$@"
93 94 95
}


Vitaly Lipatov's avatar
Vitaly Lipatov committed
96 97 98
# Used DISTRNAME
set_target_pkg_env()
{
Vitaly Lipatov's avatar
Vitaly Lipatov committed
99
	[ -n "$DISTRNAME" ] || fatal "Missing DISTRNAME in set_target_pkg_env."
Vitaly Lipatov's avatar
Vitaly Lipatov committed
100 101 102 103 104 105
	PKGFORMAT=$($DISTRVENDOR -p "$DISTRNAME")
	PKGVENDOR=$($DISTRVENDOR -s "$DISTRNAME")
	RPMVENDOR=$($DISTRVENDOR -n "$DISTRNAME")
}

# Print command line and run command line
106
showcmd()
Vitaly Lipatov's avatar
Vitaly Lipatov committed
107
{
108 109 110
	if [ -z "$quiet" ] ; then
		set_boldcolor $GREEN
		local PROMTSIG="\$"
111
		[ "$EFFUID" = 0 ] && PROMTSIG="#"
112 113
		echo " $PROMTSIG $@"
		restore_color
114
	fi >&2
115 116 117 118 119
}

# Print command line and run command line
docmd()
{
120
	showcmd "$@$EXTRA_SHOWDOCMD"
121 122
#FIXME
	$@
Vitaly Lipatov's avatar
Vitaly Lipatov committed
123 124
}

125
# Run every arg with docmd
126 127
docmd_foreach()
{
128
	local cmd pkg
129 130 131 132
	cmd="$1"
	#showcmd "$@"
	shift
	for pkg in "$@" ; do
133
		docmd "$cmd" $pkg
134 135 136
	done
}

137
# Print command line and run command line with SUDO
138
sudocmd()
139
{
140
	showcmd "$SUDO $@"
141
	$SUDO $@
142 143
}

144
# Run every arg with sudocmd
145
# Returns on any error
146 147
sudocmd_foreach()
{
148
	local cmd pkg
149 150 151 152
	cmd="$1"
	#showcmd "$@"
	shift
	for pkg in "$@" ; do
153
		sudocmd "$cmd" $pkg || return
154 155 156
	done
}

157 158 159 160 161 162 163 164
# add realpath if missed
if ! which realpath 2>/dev/null >/dev/null ; then
realpath()
{
	readlink -f "$@"
}
fi

165 166
get_firstarg()
{
167
	echon "$1"
168 169 170 171 172 173
}

get_lastarg()
{
	local lastarg
	eval lastarg=\${$#}
174
	echon "$lastarg"
175 176
}

177

Vitaly Lipatov's avatar
Vitaly Lipatov committed
178 179 180 181 182 183 184 185 186 187 188 189 190
filter_strip_spaces()
{
        # possible use just
        #xargs echo
        sed -e "s| \+| |g" | \
                sed -e "s|^ ||" | sed -e "s| \$||"
}

strip_spaces()
{
        echo "$*" | filter_strip_spaces
}

191 192 193 194 195 196
# param true false
subst_option()
{
	eval "[ -n \"\$$1\" ]" && echo "$2" || echo "$3"
}

197 198 199 200
store_output()
{
    # use make_temp_file from etersoft-build-utils
    RC_STDOUT=$(mktemp)
201 202
    local CMDSTATUS=$RC_STDOUT.pipestatus
    echo 1 >$CMDSTATUS
203
    #RC_STDERR=$(mktemp)
204
    ( $@ 2>&1 ; echo $? >$CMDSTATUS ) | tee $RC_STDOUT
205 206
    return $(cat $CMDSTATUS)
    # bashism
207
    # http://tldp.org/LDP/abs/html/bashver3.html#PIPEFAILREF
208
    #return $PIPESTATUS
209 210
}

211 212 213 214 215 216
showcmd_store_output()
{
    showcmd "$@"
    store_output "$@"
}

217 218
clean_store_output()
{
219
    rm -f $RC_STDOUT $RC_STDOUT.pipestatus
220 221
}

222
# run epm, possible from side repo
223 224
epm()
{
225 226
	[ -n "$PROGNAME" ] || fatal "Can't use epm call from the piped script"
	$PROGDIR/$PROGNAME $@
227
}
Vitaly Lipatov's avatar
Vitaly Lipatov committed
228 229 230 231 232

# Print error message and stop the program
fatal()
{
	if [ -z "$TEXTDOMAIN" ] ; then
Vitaly Lipatov's avatar
Vitaly Lipatov committed
233
		echo "Error: $@" >&2
Vitaly Lipatov's avatar
Vitaly Lipatov committed
234 235
#	else
#		echog "Error in $0: $@" >&2
Vitaly Lipatov's avatar
Vitaly Lipatov committed
236 237 238
	fi
	exit 1
}
239

Vitaly Lipatov's avatar
Vitaly Lipatov committed
240 241 242 243 244 245 246 247 248 249
# Print warning message
warning()
{
	if [ -z "$TEXTDOMAIN" ] ; then
		echo "Warning: $@" >&2
#	else
#		echog "Error in $0: $@" >&2
	fi
}

250 251 252 253
info()
{
	[ -n "$quiet" ] && return

254 255 256 257 258 259 260
	# print message to stderr if stderr forwarded to (a file)
	if isatty2 ; then
		isatty || return 0
		echo "$@"
	else
		echo "$@" >&2
	fi
261 262
}

263 264
set_sudo()
{
265 266 267
	SUDO=""
	# skip SUDO if disabled
	[ -n "$EPMNOSUDO" ] && return
268 269 270 271
	if [ "$DISTRNAME" = "Cygwin" ] || [ "$DISTRNAME" = "Windows" ] ; then
		# skip sudo using on Windows
		return
	fi
272

273
	EFFUID=`id -u`
274 275

	# do not need sudo
276
	[ $EFFUID = "0" ] && return
277 278

	# use sudo if possible
279 280
	if which sudo >/dev/null 2>/dev/null ; then
		SUDO="sudo --"
281
		# check for < 1.7 version which do not support -- (and --help possible too)
282
		sudo -h 2>/dev/null | grep -q "  --" || SUDO="sudo"
283 284
		return
	fi
285 286

	SUDO="fatal 'Can't find sudo. Please install sudo or run epm under root.'"
287 288
}

289 290
# wait for n seconds (if possible) during executing command
# args: seconds command
291 292 293
withtimeout()
{
	local TO=$(which timeout 2>/dev/null || which gtimeout 2>/dev/null)
Vitaly Lipatov's avatar
Vitaly Lipatov committed
294 295 296 297 298
	if [ -x "$TO" ] ; then
		$TO $@
		return
	fi
	# fallback: drop time arg and run without timeout
299 300
	shift
	$@
301 302
}

303 304 305 306 307 308 309
set_eatmydata()
{
	# skip if disabled
	[ -n "$EPMNOEATMYDATA" ] && return
	# use if possible
	which eatmydata >/dev/null 2>/dev/null || return
	SUDO="$SUDO eatmydata"
310
	[ -n "$verbose" ] && info "Uwaga! eatmydata is installed, we will use it for disable all sync operations."
Vitaly Lipatov's avatar
Vitaly Lipatov committed
311
	return 0
312 313
}

314 315
# 
__get_package_for_command()
316
{
317
	case "$1" in
318
		equery|revdep-rebuild)
319
			echo 'gentoolkit'
320
			;;
321
		update-kernel|remove-old-kernels)
322
			echo 'update-kernel'
323 324 325 326
			;;
	esac
}

327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353
# TODO:
confirm() {
    local response
    # call with a prompt string or use a default
    read -r -p "${1:-Are you sure? [y/N]} " response
    case $response in
        [yY][eE][sS]|[yY])
            true
            ;;
        *)
            false
            ;;
    esac
}

assure_root()
{
	[ "$EFFUID" = 0 ] || fatal "run me only under root"
}

regexp_subst()
{
	local expression="$1"
	shift
	sed -i -r -e "$expression" "$@"
}

Vitaly Lipatov's avatar
Vitaly Lipatov committed
354
# TODO: we we can't use epm directly?
355 356 357
assure_exists()
{
	load_helper epm-assure
Vitaly Lipatov's avatar
Vitaly Lipatov committed
358
	local package="$2"
359
	local textpackage=
Vitaly Lipatov's avatar
Vitaly Lipatov committed
360
	[ -n "$package" ] || package="$(__get_package_for_command "$1")"
361 362
	[ -n "$3" ] && textpackage=" >= $3"
	__epm_assure "$1" $package $3 || fatal "Can't assure in '$1' command from $package$textpackage package"
363 364
}

Vitaly Lipatov's avatar
Vitaly Lipatov committed
365 366
eget()
{
Vitaly Lipatov's avatar
Vitaly Lipatov committed
367 368
	assure_exists wget
	$SHAREDIR/tools_eget "$@"
Vitaly Lipatov's avatar
Vitaly Lipatov committed
369 370
}

371
# TODO: improve and drop!
372 373 374
get_package_type()
{
	local i
375 376 377 378 379 380 381 382 383
	case $1 in
		*.deb)
			echo "deb"
			return
			;;
		*.rpm)
			echo "rpm"
			return
			;;
384 385 386 387 388 389 390 391
		*.txz)
			echo "txz"
			return
			;;
		*.tbz)
			echo "tbz"
			return
			;;
392 393 394 395
		*.exe)
			echo "exe"
			return
			;;
396 397 398 399
		*.msi)
			echo "msi"
			return
			;;
400 401 402 403 404 405 406
		*)
			#fatal "Don't know type of $1"
			# return package name for info
			echo "$1"
			return 1
			;;
	esac
407 408 409
}


410 411 412
# print options description from HELPCMD/HELPOPT lines in the code
get_help()
{
413 414 415 416
    if [ "$0" = "/dev/stdin" ] || [ "$0" = "sh" ] ; then
        return
    fi

417
    grep -v -- "^#" $0 | grep -- "# $1" | while read n ; do
418 419 420 421 422 423
        opt=$(echo $n | sed -e "s|) # $1:.*||g")
        desc=$(echo $n | sed -e "s|.*) # $1:||g")
        printf "    %-20s %s\n" $opt "$desc"
    done
}

424

425 426 427 428
# FIXME: detect if not recognized
set_pm_type()
{
	local CMD
429 430 431

	# Fill for use: PMTYPE, DISTRNAME, DISTRVERSION, PKGFORMAT, PKGVENDOR, RPMVENDOR
	DISTRVENDOR=$PROGDIR/distr_info
432
	[ -n "$DISTRNAME" ] || DISTRNAME=$($DISTRVENDOR -d) || fatal "Can't get distro name."
433 434 435
	[ -n "$DISTRVERSION" ] || DISTRVERSION=$($DISTRVENDOR -v)
	set_target_pkg_env

436 437 438 439 440 441
# override package manager detection result
if [ -n "$FORCEPM" ] ; then
	PMTYPE=$FORCEPM
	return
fi

442 443
# TODO: move it in distr_vendor?
# FIXME: some problems with multibased distros (Server Edition on CentOS and Desktop Edition on Ubuntu)
444
case $DISTRNAME in
445
	ALTLinux)
446
		CMD="apt-rpm"
447
		#which ds-install 2>/dev/null >/dev/null && CMD=deepsolver-rpm
448 449
		;;
	PCLinux)
450 451
		CMD="apt-rpm"
		;;
452
	Ubuntu|Debian|Mint|AstraLinux|Elbrus)
453
		CMD="apt-dpkg"
Vitaly Lipatov's avatar
Vitaly Lipatov committed
454
		#which aptitude 2>/dev/null >/dev/null && CMD=aptitude-dpkg
455
		which snappy 2>/dev/null >/dev/null && CMD=snappy
456
		;;
Vitaly Lipatov's avatar
Vitaly Lipatov committed
457
	Mandriva|ROSA)
458 459
		CMD="urpm-rpm"
		;;
460 461
	FreeBSD|NetBSD|OpenBSD|Solaris)
		CMD="pkgsrc"
462
		which pkg 2>/dev/null >/dev/null && CMD=pkgng
463
		;;
464 465 466
	Gentoo)
		CMD="emerge"
		;;
467 468 469
	ArchLinux)
		CMD="pacman"
		;;
470
	Fedora|LinuxXP|ASPLinux|CentOS|RHEL|Scientific|GosLinux)
471
		CMD="yum-rpm"
472
		which dnf 2>/dev/null >/dev/null && test -d /var/lib/dnf/yumdb && CMD=dnf-rpm
473
		;;
474
	Slackware)
475
		CMD="slackpkg"
476
		;;
477
	SUSE|SLED|SLES|Tumbleweed)
478 479
		CMD="zypper-rpm"
		;;
480 481 482
	ForesightLinux|rPathLinux)
		CMD="conary"
		;;
483
	Windows)
484
		CMD="chocolatey"
485
		;;
486 487 488 489 490 491
	MacOS)
		CMD="homebrew"
		;;
	OpenWRT)
		CMD="ipkg"
		;;
492 493 494
	GNU/Linux/Guix)
		CMD="guix"
		;;
495 496 497
	Android)
		CMD="android"
		;;
498 499 500
	Cygwin)
		CMD="aptcyg"
		;;
501 502 503
	alpine)
		CMD="apk"
		;;
504 505 506
	TinyCoreLinux)
		CMD="tce"
		;;
507 508 509
	VoidLinux)
		CMD="xbps"
		;;
510
	*)
511
		fatal "Have no suitable DISTRNAME $DISTRNAME"
512 513 514 515
		;;
esac
PMTYPE=$CMD
}
516

517 518 519 520 521 522 523 524 525

is_active_systemd()
{
	local a
	SYSTEMCTL=/bin/systemctl
	SYSTEMD_CGROUP_DIR=/sys/fs/cgroup/systemd
	[ -x "$SYSTEMCTL" ] || return
	[ -d "$SYSTEMD_CGROUP_DIR" ] || return
	a= mountpoint -q "$SYSTEMD_CGROUP_DIR" || return
526
	readlink /sbin/init | grep -q 'systemd' || return
527
	# some hack
528
	ps ax | grep '[s]ystemd' | grep -q -v 'systemd-udev'
529
}